//////////////////////////////////////////////////////////////////////
// blit.c - A simple picture viewer by Joe Kopena
// If you do something with this code, all I ask is that you tell me about it
// I accept no responsibility for the consequences of using this code
// Copyright Joe Kopena 1997-98
//////////////////////////////////////////////////////////////////////

#include <stdlib.h>
#include <stdio.h>

#include "allegro.h"


int main(int argc, char *argv[]) {
BITMAP *the_image;
PALLETE the_pallete;
char mook[80];
int i;

   if (argc < 2) {
      printf("Usage: blit filename.[bmp|lbm|pcx|tga]'\n\t\t(you may specify more than one file or use a wildcard)\n");
      exit(1);
   }

   allegro_init();
   install_keyboard(); 
   set_gfx_mode(GFX_AUTODETECT, 640, 480, 0, 0);

   for (i = 1; i < argc; i++) {
      clear(screen);

      the_image = load_bitmap(argv[i], the_pallete);
      if (!the_image) {
         printf("Error reading bitmap file '%s'\n", argv[i]);
         exit(1);
      }

      set_pallete(the_pallete);

      blit(the_image, screen, 0, 0, (SCREEN_W-the_image->w)/2,
		     (SCREEN_H-the_image->h)/2, the_image->w, the_image->h);

      sprintf(mook, "%s (%i, %i)", argv[i], the_image->w, the_image->h);
      textout(screen, font, mook, 0, 0, 1);

      destroy_bitmap(the_image);

      readkey();
   } // for i

   clear_keybuf();

return 0;
}
