#include <stdio.h>
#include <allegro.h>

void dispProgress(int pos) {
static int count = 0;

   if (count >= 4) {
      putch('.');
      count = 0;
   } else count++;

// end dispProgress
}

int findColor(char r, char g, char b) {

   return rgb_map->data[r/2][g/2][b/2];

// end findColor
return -1;
}

int main(int argc, char *argv[]) {
int err = 0;
BITMAP *bitmap;
PALETTE pal;
RGB_MAP rgbMap;
FILE *file;

   if (argc < 3 || (!strstr(argv[1], ".pcx") && !strstr(argv[1], ".bmp") &&
                !strstr(argv[1], ".lbm") && !strstr(argv[1], ".tga"))) {
      printf("Usage: paldef.exe <bitmap> <header>\n");
      printf("       <bitmap> is a PCX, TGA, BMP or LBM file\n");
      printf("       <header> is a valid filename\n");
      exit(-1);
   }

   bitmap = load_bitmap(argv[1], pal);
   if (!bitmap) {
      printf("Couldn't load bitmap.\n");
      exit(-2);
   } // !bitmap

   printf("                        Generating RGB table:\n\t");
   fflush(stdout);
   create_rgb_table(&rgbMap, pal, dispProgress);
   rgb_map = &rgbMap;

//   if (set_gfx_mode(GFX_AUTODETECT, 320, 200, 0, 0) < 0) {
            // Pointless, but I saw no way around it
            // I believe the gfx mode has to be set for makecol* to work

//      printf("Could not set video mode.\n");
//      exit(-4);
//   }

   printf("\n\nWorking... ");

   file = fopen(argv[2], "wt");
   if (!file) {
      printf("Could not create file for write.\n");
      exit(-3);
   }

//   set_palette(pal);

//   fprintf(stderr, "Meep: (%i, %i, %i)=%i\n", 63, 63, 63, rgb_map->data[63/2][63/2][63/2]);

   fprintf(file, "/********************************************************************\n");
   fprintf(file, "** This file was generated by Scarius' PalDef. Be warned, although **\n");
   fprintf(file, "** you can edit this with no problem, your changes will be         **\n");
   fprintf(file, "** overwritten if you run PalDef again. Be warned, if PalDef can't **\n");
   fprintf(file, "** find the color, you might get some weird results :)             **\n");
   fprintf(file, "********************************************************************/\n\n");
   fprintf(file, "#ifndef PALETTE_HEADER\n#define PALETTE_HEADER\n\n");


   fprintf(file, "/* Palette taken from %s */\n\n", argv[1]);

   fprintf(file, "#define BLACK           %i\n", findColor(0, 0, 0));

   fprintf(file, "#define BRIGHT_WHITE    %i\n", findColor(63, 63, 63));
   fprintf(file, "#define BRIGHT_BLUE     %i\n", findColor(0, 0, 63));
   fprintf(file, "#define BRIGHT_RED      %i\n", findColor(63, 0, 0));
   fprintf(file, "#define BRIGHT_GREEN    %i\n", findColor(0, 63, 0));
   fprintf(file, "#define BRIGHT_PURPLE   %i\n", findColor(63, 0, 63));
   fprintf(file, "#define BRIGHT_YELLOW   %i\n", findColor(63, 63, 0));
   fprintf(file, "#define BRIGHT_LT_BLUE  %i\n", findColor(0, 63, 63));
   fprintf(file, "#define BRIGHT_PINK     %i\n\n", findColor(63, 0, 32));

   fprintf(file, "#define DK_WHITE        %i\n", findColor(32, 32, 32));
   fprintf(file, "#define DK_BLUE         %i\n", findColor(0, 0, 32));
   fprintf(file, "#define DK_RED          %i\n", findColor(32, 0, 0));
   fprintf(file, "#define DK_GREEN        %i\n", findColor(0, 32, 0));
   fprintf(file, "#define DK_PURPLE       %i\n", findColor(32, 0, 32));
   fprintf(file, "#define DK_YELLOW       %i\n", findColor(32, 32, 0));
   fprintf(file, "#define BK_LT_BLUE      %i\n", findColor(0, 32, 32));
   fprintf(file, "#define DK_PINK         %i\n\n", findColor(32, 0, 16));

   fprintf(file, "#define ORANGE          %i\n", findColor(63, 32, 0));
   fprintf(file, "#define GOLD            %i\n", findColor(41, 25, 4));
   fprintf(file, "#define FLESH           %i\n\n", findColor(59, 53, 41));

//   fprintf(file, "#define BLACK %i\n", findColor(0, 0, 0));

   fprintf(file, "#endif /* PALETTE_HEADER */\n");

   fclose(file);
   destroy_bitmap(bitmap);

   printf("done.\n\n");

   allegro_exit();

// end main
return err;
}

