#include <stdio.h>
#include <allegro.h>

int main(int argc, char *argv[]) {
int err = 0, color, x, y, oc;
BITMAP *bitmap;
PALETTE pal;
char mook[32];

   if (argc < 2) {
      printf("Usage: showpal.exe <bitmap>\n");
      printf("       <bitmap> is a valid pcx, bmp, tga or lbm file\n");
      exit(-1);
   }

   allegro_init();
   install_keyboard();
   install_timer();
   if (install_mouse() < 0) {
      printf("Couldn't load the mouse.\n");
      exit(-3);
   }

   set_gfx_mode(GFX_AUTODETECT, 640, 480, 0, 0);

   bitmap = load_bitmap(argv[1], pal);
   if (!bitmap) {
      allegro_exit();
      printf("Couldn't open bitmap %s\n", argv[1]);
      exit(-2);
   }

   set_palette(pal);

//   for(x = 0; x < 256; x++) {
//         line(screen, x*2, 0, x*2, 480, x);
//         line(screen, (x*2)+1, 0, (x*2)+1, 480, x);
//   }
//   getch();
//     readkey();
//   clear(screen);

   x = 0;
   y = 0;

   for (color = 0; color < 256; color++) {
       rectfill(screen, x*20, y*20, (x+1)*20, (y+1)*20, color);

       x++;
       if (x >= 32) {
          x = 0;
          y++;
       }
   } // for color

//   show_mouse(screen);
//   show_mouse(NULL);

   oc = 0;

   while (!keypressed()) {

         x = mouse_x / 20;
         y = mouse_y / 20;

         color = (y*32)+x;

         if (color != oc) {
            show_mouse(NULL);

            if (color < 256 && color >= 0) {
               sprintf(mook, "#%i (%i, %i, %i)      ", color, pal[color].r, pal[color].g, pal[color].b);
            } else
              sprintf(mook, "                        ");  // Erase old stuff

            textout(screen, font, mook, 0, 470, makecol8(63-pal[0].r, 63-pal[0].g, 63-pal[0].b));
                        // Display it in the inverse color of the background

            show_mouse(screen);
            oc = color;
         } // != oc

   } // !keypressed

   readkey();

   destroy_bitmap(bitmap);

// end main
return err;
}

